module Main (main) where

import Lib
import System.Environment(getArgs)
import Text.Read (readMaybe)
import System.Exit (exitFailure)


-- getUsageError :: String
-- getUsageError = "Usage: stack run <number>"

-- Validate both number and depth
validateNum :: Int -> IO ()
validateNum num
    | num < 1 || num > 100 = do
        putStrLn "Error: The integer must be between 1 and 100."
        exitFailure
    | otherwise = return ()

validateDepth :: Int -> Int -> IO ()
validateDepth depth n
    | depth < 0 || depth >= n * n = do
        putStrLn $ "Error: Depth must be between 0 and " ++ show (n * n - 1) ++ "."
        exitFailure
    | otherwise = return ()

-- Main function updated to accept depth
main :: IO ()
main = do
    args <- getArgs
    case args of
        [potentialNum, potentialDepth] -> do
            case (readMaybe potentialNum :: Maybe Int, readMaybe potentialDepth :: Maybe Int) of
                (Just num, Just depth) -> do
                    validateNum num
                    validateDepth depth num
                    putStrLn (someFunc num depth)
                _ -> do
                    putStrLn "Error: Both arguments must be integers. Number must be between 1 and 100. Depth must be valid."
                    exitFailure
        _ -> do
            putStrLn "Error: Please provide exactly two arguments (number and depth)."
            exitFailure
