#!/bin/bash

# Fixed board size
N=6

# Output file
OUTPUT_FILE="depthParV1.txt"

# Clear the output file if it exists
> $OUTPUT_FILE

for depth in $(seq 1 $((N * N - 1))); do
    echo "Running with depth=$depth..."
    
    # Add a header for this run
    echo "=== Test with N=5, depth=$depth ===" >> $OUTPUT_FILE
    
    # Run the program and append output to file
    stack run $N $depth -- +RTS -N6 -s -ls >> $OUTPUT_FILE
    
    # Add a separator
    echo -e "\n\n" >> $OUTPUT_FILE
done

echo "Testing complete. Results saved to $OUTPUT_FILE"